NUM_CHIPLETS = 8
NUM_PE = 8
TOTAL_PE = 64
DELAY = 10
INTERVAL = 20
TYPE_IF = 1
TYPE_WK = 2
TYPE_OF = 3
START_PE = 8
PE_GB = 73

DATA_XML_START = """<?xml version="1.0" ?>
<data xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
 <dataTypes>
    <dataType id="0">
      <name value="TYPE_PE_TO_PE"/>
    </dataType>
    <dataType id="1">
      <name value="TYPE_IF"/>
    </dataType>
    <dataType id="2">
      <name value="TYPE_WK"/>
    </dataType>
    <dataType id="3">
      <name value="TYPE_OF"/> 
    </dataType>
  </dataTypes>
  <tasks>
  """

DATA_XML_END = """ </tasks>
</data>
"""

TASK =  """<task id="{}">
      <start min="0" max="0"/>
      <duration min="-1" max="-1"/>
      <repeat min="1" max="1"/>
      <generates>
        <possibility id="0">
          <probability value="1"/>
          <destinations>{}
          </destinations>
        </possibility>
      </generates>
      <requires>{}
      </requires>
    </task>
    """

DEST = """
            <destination id="{}">
              <delay min="{}" max="{}"/>
              <interval min="{}" max="{}"/>
              <count min="{}" max="{}"/>
              <type value="{}"/>
              <task value="{}"/>
            </destination>"""

REQ =  """
        <requirement id="{}">
          <type value="{}"/>
          <source value="{}"/>
          <count max="{}" min="{}"/>
        </requirement>"""


MAP = """<?xml version="1.0" ?>
<map xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
{}
</map>
"""

BIND = """  <bind>
    <task value="{}"/>
    <node value="{}"/>
  </bind>
"""