#ifndef O_E_CONVERTER_H
#define O_E_CONVERTER_H

#include <systemc.h>
#include <tlm.h>
#include <tlm_utils/simple_target_socket.h>
#include <tlm_utils/simple_initiator_socket.h>
#include <utils/configuration.h>
#include <utils/noc_logger.h>
#include <ctime>

using namespace tlm;
using namespace sc_core;

class O_E_converter : public sc_module {
public:
    // TLM sockets
    
    tlm_utils::simple_target_socket<O_E_converter> ci_SingleChiplet_receive_socket; // Receiving from Chiplet Interface
    tlm_utils::simple_target_socket<O_E_converter> ci_CrossChiplet_receive_socket; // Receiving from Chiplet Interface
    tlm_utils::simple_initiator_socket<O_E_converter> ci_send_socket;  // Sending to Chiplet Interface
    
    tlm_utils::simple_target_socket<O_E_converter> ni_to_oec_receive_socket; // Receiving from ni
    tlm_utils::simple_initiator_socket<O_E_converter> ni_SingleChiplet_send_socket;  // Sending to ni
    tlm_utils::simple_initiator_socket<O_E_converter> ni_CrossChiplet_send_socket;  // Sending to ni

    SC_HAS_PROCESS(O_E_converter);

    O_E_converter(sc_module_name name);

    int O_E_converter_id;

private:
    // Handle incoming transactions from the Chiplet Interface
    void ci_SingleChiplet_b_transport(tlm_generic_payload& trans, sc_time& delay);
    void ci_CrossChiplet_b_transport(tlm_generic_payload& trans, sc_time& delay);
    
    // Handle incoming transactions from the processing element
    void ni_b_transport(tlm_generic_payload& trans, sc_time& delay);

    //forward transactions to ni
    void ni_SingleChiplet_send_transaction(PESendPayload& trans, sc_time& delay, int single_wavelength);
    void chiplet_CrossChiplet_send_transaction(PESendPayload& trans, sc_time& delay, int cross_wavelength);
    
    // Forward transaction to Chiplet Interface
    void chiplet_send_transaction(PESendPayload& trans, sc_time& delay); 

    void log_info(std::string msg);

    void log_error(std::string msg);
};

#endif // INTERPOSER_INTERFACE_H