
#pragma once

#include <systemc>
#include "configuration.h"
#include "utils.h"

#define DEF_LOGFILENAME "./out/report.log"

#define GB_LOGFILENAME   "./out/gb_comm.log"
#define GB_LOG           "GlobalBuffer"

#define I_LOGFILENAME   "./out/interposer_comm.log"
#define I_LOG           "InterposerInterface"

#define C_LOGFILENAME   "./out/chiplet_comm.log"
#define C_LOG           "ChipletInterface"

#define OEC_LOGFILENAME "./out/oec_comm.log"
#define OEC_LOG         "OpticalToElectrical"

#define PE_LOGFILENAME "./out/pe_comm.log"
#define PE_LOG         "ProcessingElement"

#define NOC_Set_LOGFILENAME "./out/noc_setup.log"
#define NOC_Set_LOG         "NoC"

#define NI_LOGFILENAME "./out/ni_comm.log"
#define NI_LOG         "NetworkInterface"

#define NI_GB_LOGFILENAME "./out/ni_gb_comm.log"
#define NI_GB_LOG         "NetworkInterfaceGB"

#define NM_LOGFILENAME "./out/nm_conn.log"
#define NM_LOG         "NetworkManager"

// #define RATA_LOGFILENAME "./out/ratatoskr.log"
// #define RATA_LOG         "GlobalResources"

#define ASCII_RED       "31"
#define ASCII_GREEN     "32"
#define ASCII_YELLOW    "33"

const std::string str_dir[Direction::num_dirs] = {"local","east","west","north","south","up","down"};

/** 
 * Handles log messages (writes to console and log)
 *
 * @param report    report object with log information
 * @param actions   valid actions
 */
void report_handler(const sc_report& report, const sc_actions& actions);

/** 
 * Configure sc report handler filename and actions
 */
void setup_logger();

//void creds_log_info(std::string router_name, uint8_t link, uint8_t num_creds, bool is_ext);

/** 
 * Log to cout
 */
void cout_logger(std::string msg);
